diff --git a/gcc/m2/mc-boot/Gwlists.cc b/gcc/m2/mc-boot/Gwlists.cc
index fa3f73ac212..87daa42c3ef 100644
--- a/gcc/m2/mc-boot/Gwlists.cc
+++ b/gcc/m2/mc-boot/Gwlists.cc
@@ -42,9 +42,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #   undef NULL
 #   define NULL 0
 #endif
-#define _wlists_H
 #define _wlists_C
 
+#include "Gwlists.h"
 #   include "GStorage.h"
 
 typedef struct wlists_performOperation_p wlists_performOperation;
@@ -54,16 +54,13 @@ typedef struct wlists__T1_r wlists__T1;
 
 typedef struct wlists__T2_a wlists__T2;
 
-typedef wlists__T1 *wlists_wlist;
-
-typedef void (*wlists_performOperation_t) (unsigned int);
-struct wlists_performOperation_p { wlists_performOperation_t proc; };
+typedef wlists__T1 *wlists_wlist__opaque;
 
 struct wlists__T2_a { unsigned int array[maxNoOfElements-1+1]; };
 struct wlists__T1_r {
                       unsigned int noOfElements;
                       wlists__T2 elements;
-                      wlists_wlist next;
+                      wlists_wlist__opaque next;
                     };
 
 
@@ -149,14 +146,14 @@ extern "C" wlists_wlist wlists_duplicateList (wlists_wlist l);
    removeItem - remove an element at index, i, from the wlist data type.
 */
 
-static void removeItem (wlists_wlist p, wlists_wlist l, unsigned int i);
+static void removeItem (wlists_wlist__opaque p, wlists_wlist__opaque l, unsigned int i);
 
 
 /*
    removeItem - remove an element at index, i, from the wlist data type.
 */
 
-static void removeItem (wlists_wlist p, wlists_wlist l, unsigned int i)
+static void removeItem (wlists_wlist__opaque p, wlists_wlist__opaque l, unsigned int i)
 {
   l->noOfElements -= 1;
   while (i <= l->noOfElements)
@@ -178,12 +175,12 @@ static void removeItem (wlists_wlist p, wlists_wlist l, unsigned int i)
 
 extern "C" wlists_wlist wlists_initList (void)
 {
-  wlists_wlist l;
+  wlists_wlist__opaque l;
 
   Storage_ALLOCATE ((void **) &l, sizeof (wlists__T1));
   l->noOfElements = 0;
-  l->next = NULL;
-  return l;
+  l->next = static_cast<wlists_wlist__opaque> (NULL);
+  return static_cast<wlists_wlist> (l);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -197,9 +194,9 @@ extern "C" void wlists_killList (wlists_wlist *l)
 {
   if ((*l) != NULL)
     {
-      if ((*l)->next != NULL)
+      if (static_cast<wlists_wlist__opaque> ((*l))->next != NULL)
         {
-          wlists_killList (&(*l)->next);
+          wlists_killList (reinterpret_cast<wlists_wlist *> (&static_cast<wlists_wlist__opaque> ((*l))->next));
         }
       Storage_DEALLOCATE ((void **) &(*l), sizeof (wlists__T1));
     }
@@ -212,21 +209,21 @@ extern "C" void wlists_killList (wlists_wlist *l)
 
 extern "C" void wlists_putItemIntoList (wlists_wlist l, unsigned int c)
 {
-  if (l->noOfElements < maxNoOfElements)
+  if (static_cast<wlists_wlist__opaque> (l)->noOfElements < maxNoOfElements)
     {
-      l->noOfElements += 1;
-      l->elements.array[l->noOfElements-1] = c;
+      static_cast<wlists_wlist__opaque> (l)->noOfElements += 1;
+      static_cast<wlists_wlist__opaque> (l)->elements.array[static_cast<wlists_wlist__opaque> (l)->noOfElements-1] = c;
     }
-  else if (l->next != NULL)
+  else if (static_cast<wlists_wlist__opaque> (l)->next != NULL)
     {
       /* avoid dangling else.  */
-      wlists_putItemIntoList (l->next, c);
+      wlists_putItemIntoList (static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next), c);
     }
   else
     {
       /* avoid dangling else.  */
-      l->next = wlists_initList ();
-      wlists_putItemIntoList (l->next, c);
+      static_cast<wlists_wlist__opaque> (l)->next = static_cast<wlists_wlist__opaque> (wlists_initList ());
+      wlists_putItemIntoList (static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next), c);
     }
 }
 
@@ -239,15 +236,15 @@ extern "C" unsigned int wlists_getItemFromList (wlists_wlist l, unsigned int n)
 {
   while (l != NULL)
     {
-      if (n <= l->noOfElements)
+      if (n <= static_cast<wlists_wlist__opaque> (l)->noOfElements)
         {
-          return l->elements.array[n-1];
+          return static_cast<wlists_wlist__opaque> (l)->elements.array[n-1];
         }
       else
         {
-          n -= l->noOfElements;
+          n -= static_cast<wlists_wlist__opaque> (l)->noOfElements;
         }
-      l = l->next;
+      l = static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next);
     }
   return static_cast<unsigned int> (0);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -272,9 +269,9 @@ extern "C" unsigned int wlists_getIndexOfList (wlists_wlist l, unsigned int c)
   else
     {
       i = 1;
-      while (i <= l->noOfElements)
+      while (i <= static_cast<wlists_wlist__opaque> (l)->noOfElements)
         {
-          if (l->elements.array[i-1] == c)
+          if (static_cast<wlists_wlist__opaque> (l)->elements.array[i-1] == c)
             {
               return i;
             }
@@ -283,7 +280,7 @@ extern "C" unsigned int wlists_getIndexOfList (wlists_wlist l, unsigned int c)
               i += 1;
             }
         }
-      return l->noOfElements+(wlists_getIndexOfList (l->next, c));
+      return static_cast<wlists_wlist__opaque> (l)->noOfElements+(wlists_getIndexOfList (static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next), c));
     }
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -306,8 +303,8 @@ extern "C" unsigned int wlists_noOfItemsInList (wlists_wlist l)
     {
       t = 0;
       do {
-        t += l->noOfElements;
-        l = l->next;
+        t += static_cast<wlists_wlist__opaque> (l)->noOfElements;
+        l = static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next);
       } while (! (l == NULL));
       return t;
     }
@@ -337,33 +334,33 @@ extern "C" void wlists_includeItemIntoList (wlists_wlist l, unsigned int c)
 
 extern "C" void wlists_removeItemFromList (wlists_wlist l, unsigned int c)
 {
-  wlists_wlist p;
+  wlists_wlist__opaque p;
   unsigned int i;
   bool found;
 
   if (l != NULL)
     {
       found = false;
-      p = NULL;
+      p = static_cast<wlists_wlist__opaque> (NULL);
       do {
         i = 1;
-        while ((i <= l->noOfElements) && (l->elements.array[i-1] != c))
+        while ((i <= static_cast<wlists_wlist__opaque> (l)->noOfElements) && (static_cast<wlists_wlist__opaque> (l)->elements.array[i-1] != c))
           {
             i += 1;
           }
-        if ((i <= l->noOfElements) && (l->elements.array[i-1] == c))
+        if ((i <= static_cast<wlists_wlist__opaque> (l)->noOfElements) && (static_cast<wlists_wlist__opaque> (l)->elements.array[i-1] == c))
           {
             found = true;
           }
         else
           {
-            p = l;
-            l = l->next;
+            p = static_cast<wlists_wlist__opaque> (l);
+            l = static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next);
           }
       } while (! ((l == NULL) || found));
       if (found)
         {
-          removeItem (p, l, i);
+          removeItem (p, static_cast<wlists_wlist__opaque> (l), i);
         }
     }
 }
@@ -379,15 +376,15 @@ extern "C" void wlists_replaceItemInList (wlists_wlist l, unsigned int n, unsign
 {
   while (l != NULL)
     {
-      if (n <= l->noOfElements)
+      if (n <= static_cast<wlists_wlist__opaque> (l)->noOfElements)
         {
-          l->elements.array[n-1] = w;
+          static_cast<wlists_wlist__opaque> (l)->elements.array[n-1] = w;
         }
       else
         {
-          n -= l->noOfElements;
+          n -= static_cast<wlists_wlist__opaque> (l)->noOfElements;
         }
-      l = l->next;
+      l = static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next);
     }
 }
 
@@ -402,9 +399,9 @@ extern "C" bool wlists_isItemInList (wlists_wlist l, unsigned int c)
 
   do {
     i = 1;
-    while (i <= l->noOfElements)
+    while (i <= static_cast<wlists_wlist__opaque> (l)->noOfElements)
       {
-        if (l->elements.array[i-1] == c)
+        if (static_cast<wlists_wlist__opaque> (l)->elements.array[i-1] == c)
           {
             return true;
           }
@@ -413,7 +410,7 @@ extern "C" bool wlists_isItemInList (wlists_wlist l, unsigned int c)
             i += 1;
           }
       }
-    l = l->next;
+    l = static_cast<wlists_wlist> (static_cast<wlists_wlist__opaque> (l)->next);
   } while (! (l == NULL));
   return false;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -446,27 +443,27 @@ extern "C" void wlists_foreachItemInListDo (wlists_wlist l, wlists_performOperat
 
 extern "C" wlists_wlist wlists_duplicateList (wlists_wlist l)
 {
-  wlists_wlist m;
+  wlists_wlist__opaque m;
   unsigned int n;
   unsigned int i;
 
-  m = wlists_initList ();
+  m = static_cast<wlists_wlist__opaque> (wlists_initList ());
   n = wlists_noOfItemsInList (l);
   i = 1;
   while (i <= n)
     {
-      wlists_putItemIntoList (m, wlists_getItemFromList (l, i));
+      wlists_putItemIntoList (static_cast<wlists_wlist> (m), wlists_getItemFromList (l, i));
       i += 1;
     }
-  return m;
+  return static_cast<wlists_wlist> (m);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_wlists_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_wlists_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_wlists_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_wlists_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc/decl.def b/gcc/m2/mc/decl.def
index 0cd8d7151f7..8f12f010850 100644
--- a/gcc/m2/mc/decl.def
+++ b/gcc/m2/mc/decl.def
@@ -249,6 +249,21 @@ PROCEDURE isTypeHidden (n: node) : BOOLEAN ;
 PROCEDURE hasHidden (n: node) : BOOLEAN ;
 
 
+(*
+   putTypeOpaque - marks type, des, as being an opaque type.
+                   TYPE des ;
+*)
+
+PROCEDURE putTypeOpaque (des: node) ;
+
+
+(*
+   isTypeOpaque - returns TRUE if type, n, is an opaque type.
+*)
+
+PROCEDURE isTypeOpaque (n: node) : BOOLEAN ;
+
+
 (*
    isVar - returns TRUE if node, n, is a type.
 *)
diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index c3ee646caaf..37fc3962695 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -81,6 +81,7 @@ CONST
    enableDefForCStrings   = FALSE ;   (* currently disabled.  *)
    enableMemsetOnAllocation = TRUE ;  (* Should we memset (..., 0, ...) the allocated mem?  *)
    forceQualified  = TRUE ;
+   debugOpaque     = FALSE ;
 
 TYPE
    language = (ansiC, ansiCP, pim4) ;
@@ -127,7 +128,7 @@ TYPE
             componentref, pointerref, arrayref, deref,
 	    equal, notequal, less, greater, greequal, lessequal,
 	    lsl, lsr, lor, land, lnot, lxor,
-	    and, or, not, identlist, vardecl, setvalue) ;
+	    and, or, not, identlist, vardecl, setvalue, opaquecast) ;
 
     node = POINTER TO nodeRec ;
 
@@ -260,12 +261,24 @@ TYPE
 			 identlist       :  identlistF       : identlistT |
 			 vardecl         :  vardeclF         : vardeclT |
                          funccall        :  funccallF        : funccallT |
-			 setvalue        :  setvalueF        : setvalueT
+			 setvalue        :  setvalueF        : setvalueT |
+                         opaquecast      :  opaquecastF      : opaquecastT
 
                          END ;
                          at: where ;
                       END ;
 
+       opaqueCastState = RECORD
+                            opaque,
+                            voidStar: BOOLEAN ;
+                         END ;
+
+       opaquecastT = RECORD
+                        (* Describes the cast of the opaque.  *)
+                        exp        : node ;
+                        opaqueState: opaqueCastState ;
+                     END ;
+
        intrinsicT = RECORD
                        args            : node ;
                        noArgs          : CARDINAL ;
@@ -298,6 +311,7 @@ TYPE
 		      args           : node ;
 		      type           : node ;
 		      funccallComment: commentPair ;
+                      opaqueState    : opaqueCastState ;
                    END ;
 
        commentT = RECORD
@@ -328,6 +342,7 @@ TYPE
                   name      :  Name ;
 		  type      :  node ;
 		  scope     :  node ;
+                  isOpaque,
 		  isHidden,
 		  isInternal:  BOOLEAN ;
                END ;
@@ -355,6 +370,7 @@ TYPE
 		 isVarParameter,
                  isUsed        :  BOOLEAN ;
                  cname         :  cnameT ;
+                 opaqueState   :  opaqueCastState ;
               END ;
 
        enumerationT = RECORD
@@ -382,6 +398,7 @@ TYPE
 		   type,
 		   scope      :  node ;
 		   isUnbounded:  BOOLEAN ;
+                   opaqueState:  opaqueCastState ;
                 END ;
 
        stringT = RECORD
@@ -412,6 +429,7 @@ TYPE
                       isUnbounded:  BOOLEAN ;
                       isForC     :  BOOLEAN ;
                       isUsed     :  BOOLEAN ;
+                      opaqueState:  opaqueCastState ;
                    END ;
 
        paramT = RECORD
@@ -421,6 +439,7 @@ TYPE
                    isUnbounded:  BOOLEAN ;
                    isForC     :  BOOLEAN ;
                    isUsed     :  BOOLEAN ;
+                   opaqueState:  opaqueCastState ;
                 END ;
 
        varargsT = RECORD
@@ -435,18 +454,20 @@ TYPE
                  END ;
 
        pointerT = RECORD
-                     type :  node ;
-                     scope:  node ;
+                     type       :  node ;
+                     scope      :  node ;
+                     opaqueState:  opaqueCastState ;
                   END ;
 
        recordfieldT = RECORD
-                         name   :  Name ;
-			 type   :  node ;
-			 tag    :  BOOLEAN ;
-			 parent :  node ;
-			 varient:  node ;
-			 scope  :  node ;
-			 cname  :  cnameT ;
+                         name       :  Name ;
+			 type       :  node ;
+			 tag        :  BOOLEAN ;
+			 parent     :  node ;
+			 varient    :  node ;
+			 scope      :  node ;
+			 cname      :  cnameT ;
+                         opaqueState:  opaqueCastState ;
                       END ;
 
        varientfieldT = RECORD
@@ -472,21 +493,24 @@ TYPE
               END ;
 
        componentrefT = RECORD
-                          rec       :  node ;
-                          field     :  node ;
-                          resultType:  node ;
+                          rec        :  node ;
+                          field      :  node ;
+                          resultType :  node ;
+                          opaqueState:  opaqueCastState ;
                        END ;
 
        pointerrefT = RECORD
-                        ptr       :  node ;
-                        field     :  node ;
-                        resultType:  node ;
+                        ptr        :  node ;
+                        field      :  node ;
+                        resultType :  node ;
+                        opaqueState:  opaqueCastState ;
                      END ;
 
        arrayrefT = RECORD
-                      array     :  node ;
-                      index     :  node ;
-                      resultType:  node ;
+                      array      :  node ;
+                      index      :  node ;
+                      resultType :  node ;
+                      opaqueState:  opaqueCastState ;
                    END ;
 
        commentPair = RECORD
@@ -596,15 +620,17 @@ TYPE
                        cname          :  cnameT ;
 		       defComment,
 		       modComment     :  commentDesc ;
+                       opaqueState    :  opaqueCastState ;
                     END ;
 
        proctypeT = RECORD
-                      parameters:  Index ;
+                      parameters :  Index ;
                       returnopt,
-                      vararg    :  BOOLEAN ;
-                      optarg    :  node ;
-		      scope     :  node ;
-                      returnType:  node ;
+                      vararg     :  BOOLEAN ;
+                      optarg     :  node ;
+		      scope      :  node ;
+                      returnType :  node ;
+                      opaqueState:  opaqueCastState ;
                    END ;
 
        binaryT = RECORD
@@ -2025,6 +2051,7 @@ BEGIN
       typeF.name := n ;
       typeF.type := NIL ;
       typeF.scope := getDeclScope () ;
+      typeF.isOpaque := FALSE ;
       typeF.isHidden := FALSE ;
       typeF.isInternal := FALSE
    END ;
@@ -2052,6 +2079,7 @@ BEGIN
          typeF.name := n ;
          typeF.type := NIL ;
          typeF.scope := getDeclScope () ;
+         typeF.isOpaque := FALSE ;
          typeF.isHidden := FALSE
       END ;
       RETURN addToScope (d)
@@ -2091,7 +2119,8 @@ BEGIN
    assert (var#NIL) ;
    assert (isVar (var)) ;
    var^.varF.type := type ;
-   var^.varF.decl := decl
+   var^.varF.decl := decl ;
+   initNodeOpaqueState (var) ;
 END putVar ;
 
 
@@ -2328,7 +2357,7 @@ END paramLeave ;
 
 
 (*
-   putReturnType - sets the return type of procedure or proctype, proc, to, type.
+   putReturnType - sets the return type of procedure or proctype proc to type.
 *)
 
 PROCEDURE putReturnType (proc, type: node) ;
@@ -2339,7 +2368,8 @@ BEGIN
       proc^.procedureF.returnType := type
    ELSE
       proc^.proctypeF.returnType := type
-   END
+   END ;
+   initNodeOpaqueState (proc)
 END putReturnType ;
 
 
@@ -2374,8 +2404,9 @@ BEGIN
       proctypeF.returnopt := FALSE ;
       proctypeF.optarg := NIL ;
       proctypeF.vararg := FALSE ;
-      proctypeF.returnType := NIL
+      proctypeF.returnType := NIL ;
    END ;
+   initNodeOpaqueState (d) ;
    RETURN d
 END makeProcType ;
 
@@ -2387,7 +2418,8 @@ END makeProcType ;
 PROCEDURE putProcTypeReturn (proc, type: node) ;
 BEGIN
    assert (isProcType (proc)) ;
-   proc^.proctypeF.returnType := type
+   proc^.proctypeF.returnType := type ;
+   initNodeOpaqueState (proc)
 END putProcTypeReturn ;
 
 
@@ -2418,6 +2450,7 @@ BEGIN
    d^.paramF.isUnbounded := FALSE ;
    d^.paramF.isForC := isDefForCNode (proc) ;
    d^.paramF.isUsed := isused ;
+   initNodeOpaqueState (d) ;
    RETURN d
 END makeNonVarParameter ;
 
@@ -2438,6 +2471,7 @@ BEGIN
    d^.varparamF.isUnbounded := FALSE ;
    d^.varparamF.isForC := isDefForCNode (proc) ;
    d^.varparamF.isUsed := isused ;
+   initNodeOpaqueState (d) ;
    RETURN d
 END makeVarParameter ;
 
@@ -3864,8 +3898,9 @@ BEGIN
       f := newNode (funccall) ;
       f^.funccallF.function := c ;
       f^.funccallF.args := n ;
-      f^.funccallF.type := NIL ;
-      initPair (f^.funccallF.funccallComment)
+      f^.funccallF.type := getType (c) ;
+      initPair (f^.funccallF.funccallComment) ;
+      initNodeOpaqueState (f)
    END ;
    RETURN f
 END makeFuncCall ;
@@ -3936,6 +3971,33 @@ BEGIN
 END hasHidden ;
 
 
+(*
+   putTypeOpaque - marks type, des, as being an opaque type.
+                   TYPE des ;
+*)
+
+PROCEDURE putTypeOpaque (des: node) ;
+VAR
+   s: node ;
+BEGIN
+   assert (des#NIL) ;
+   assert (isType (des)) ;
+   des^.typeF.isOpaque := TRUE
+END putTypeOpaque ;
+
+
+(*
+   isTypeOpaque - returns TRUE if type, n, is an opaque type.
+*)
+
+PROCEDURE isTypeOpaque (n: node) : BOOLEAN ;
+BEGIN
+   assert (n#NIL) ;
+   assert (isType (n)) ;
+   RETURN n^.typeF.isOpaque
+END isTypeOpaque ;
+
+
 (*
    putTypeInternal - marks type, des, as being an internally generated type.
 *)
@@ -4673,6 +4735,7 @@ BEGIN
    n^.componentrefF.rec := rec ;
    n^.componentrefF.field := field ;
    n^.componentrefF.resultType := getType (field) ;
+   initNodeOpaqueState (n) ;
    RETURN n
 END doMakeComponentRef ;
 
@@ -4708,6 +4771,7 @@ BEGIN
       rec^.pointerrefF.ptr := a ;
       rec^.pointerrefF.field := field ;
       rec^.pointerrefF.resultType := getType (field) ;
+      initNodeOpaqueState (rec) ;
       RETURN rec
    ELSE
       RETURN doMakeComponentRef (rec, field)
@@ -4739,6 +4803,7 @@ BEGIN
    n^.pointerrefF.ptr := ptr ;
    n^.pointerrefF.field := field ;
    n^.pointerrefF.resultType := getType (field) ;
+   initNodeOpaqueState (n) ;
    RETURN n
 END makePointerRef ;
 
@@ -5192,9 +5257,13 @@ END getMaxMinType ;
 *)
 
 PROCEDURE doGetFuncType (n: node) : node ;
+VAR
+   result: node ;
 BEGIN
    assert (isFuncCall (n)) ;
-   RETURN doSetExprType (n^.funccallF.type, getType (n^.funccallF.function))
+   result := doSetExprType (n^.funccallF.type, getType (n^.funccallF.function)) ;
+   initNodeOpaqueState (n) ;  (* Update now that the return type is known.  *)
+   RETURN result
 END doGetFuncType ;
 
 
@@ -5951,10 +6020,10 @@ BEGIN
    IF needsParen (left)
    THEN
       outText (p, '(') ;
-      doExprCup (p, left, unpackProc) ;
+      left := doExprCup (p, left, unpackProc, FALSE) ;
       outText (p, ')')
    ELSE
-      doExprCup (p, left, unpackProc)
+      left := doExprCup (p, left, unpackProc, FALSE)
    END ;
    IF l
    THEN
@@ -5968,10 +6037,10 @@ BEGIN
    IF needsParen (right)
    THEN
       outText (p, '(') ;
-      doExprCup (p, right, unpackProc) ;
+      right := doExprCup (p, right, unpackProc, FALSE) ;
       outText (p, ')')
    ELSE
-      doExprCup (p, right, unpackProc)
+      right := doExprCup (p, right, unpackProc, FALSE)
    END
 END doBinary ;
 
@@ -5991,11 +6060,12 @@ END doPostUnary ;
    doDeRefC -
 *)
 
-PROCEDURE doDeRefC (p: pretty; expr: node) ;
+PROCEDURE doDeRefC (p: pretty; expr: node) : node ;
 BEGIN
    outText (p, '(*') ;
-   doExprC (p, expr) ;
-   outText (p, ')')
+   expr := castOpaque (p, expr, FALSE) ;
+   outText (p, ')') ;
+   RETURN expr
 END doDeRefC ;
 
 
@@ -6079,7 +6149,7 @@ END getLastOp ;
 
 PROCEDURE doComponentRefC (p: pretty; l, r: node) ;
 BEGIN
-   doExprC (p, l) ;
+   flushOpaque (p, l, FALSE) ;
    outText (p, '.') ;
    doExprC (p, r)
 END doComponentRefC ;
@@ -6091,7 +6161,7 @@ END doComponentRefC ;
 
 PROCEDURE doPointerRefC (p: pretty; l, r: node) ;
 BEGIN
-   doExprC (p, l) ;
+   flushOpaque (p, l, FALSE) ;
    outText (p, '->') ;
    doExprC (p, r)
 END doPointerRefC ;
@@ -6156,23 +6226,38 @@ END isZero ;
 
 
 (*
-   doArrayRef -
+   doArrayRef - perform an array reference.  If constCast
+                then an unbounded array access will be const_cast
+                (the constCast should be TRUE if an assignment to
+                the array is required).
 *)
 
-PROCEDURE doArrayRef (p: pretty; n: node) ;
+PROCEDURE doArrayRef (p: pretty; n: node; constCast: BOOLEAN) ;
 VAR
-   t   : node ;
+   type,
+   v   : node ;
    i, c: CARDINAL ;
 BEGIN
    assert (n # NIL) ;
    assert (isArrayRef (n)) ;
-   t := skipType (getType (n^.arrayrefF.array)) ;
-   IF isUnbounded (t)
+   type := skipType (getType (n^.arrayrefF.array)) ;
+   IF isUnbounded (type)
    THEN
-      outTextN (p, getSymName (n^.arrayrefF.array))
+      v := n^.arrayrefF.array ;
+      IF constCast AND isVar (n^.arrayrefF.array) AND
+         (v^.varF.isParameter OR v^.varF.isVarParameter)
+      THEN
+         outText (p, "const_cast<") ;
+         doTypeNameC (p, getType (v)) ;
+         outText (p, ">(") ;
+         outTextN (p, getSymName (n^.arrayrefF.array)) ;
+         outText (p, ")")
+      ELSE
+         outTextN (p, getSymName (n^.arrayrefF.array))
+      END
    ELSE
       doExprC (p, n^.arrayrefF.array) ;
-      assert (isArray (t)) ;
+      assert (isArray (type)) ;
       outText (p, '.array')
    END ;
    outText (p, '[') ;
@@ -6180,16 +6265,16 @@ BEGIN
    c := expListLen (n^.arrayrefF.index) ;
    WHILE i<=c DO
       doExprC (p, getExpList (n^.arrayrefF.index, i)) ;
-      IF isUnbounded (t)
+      IF isUnbounded (type)
       THEN
          assert (c = 1)
       ELSE
-         doSubtractC (p, getMin (t^.arrayF.subr)) ;
+         doSubtractC (p, getMin (type^.arrayF.subr)) ;
 	 IF i<c
          THEN
-            assert (isArray (t)) ;
+            assert (isArray (type)) ;
             outText (p, '].array[') ;
-            t := skipType (getType (t))
+            type := skipType (getType (type))
          END
       END ;
       INC (i)
@@ -6466,7 +6551,7 @@ BEGIN
       im              :  doImC (p, n) |
       cmplx           :  doCmplx (p, n) |
 
-      deref           :  doDeRefC (p, unaryF.arg) |
+      deref           :  unaryF.arg := doDeRefC (p, unaryF.arg) |
       equal           :  doBinary (p, '==', binaryF.left, binaryF.right, TRUE, TRUE, TRUE) |
       notequal        :  doBinary (p, '!=', binaryF.left, binaryF.right, TRUE, TRUE, TRUE) |
       less            :  doBinary (p, '<', binaryF.left, binaryF.right, TRUE, TRUE, FALSE) |
@@ -6490,7 +6575,7 @@ BEGIN
       enumerationfield:  doEnumerationField (p, n) |
       string          :  doStringC (p, n) |
       var             :  doVar (p, n) |
-      arrayref        :  doArrayRef (p, n) |
+      arrayref        :  doArrayRef (p, n, FALSE) |
       funccall        :  doFuncExprC (p, n) |
       procedure       :  doProcedure (p, n) |
       recordfield     :  doRecordfield (p, n) |
@@ -6529,19 +6614,26 @@ END doExprC ;
    doExprCup -
 *)
 
-PROCEDURE doExprCup (p: pretty; n: node; unpackProc: BOOLEAN) ;
+PROCEDURE doExprCup (p: pretty; n: node;
+                     unpackProc, uncastConst: BOOLEAN) : node ;
 VAR
-   t: node ;
+   type: node ;
 BEGIN
-   doExprC (p, n) ;
-   IF unpackProc
+   IF uncastConst AND isArrayRef (n)
    THEN
-      t := skipType (getExprType (n)) ;
-      IF (t # NIL) AND isAProcType (t)
+      doArrayRef (p, n, TRUE)
+   ELSE
+      doExprC (p, n) ;
+      IF unpackProc
       THEN
-         outText (p, '.proc')
+         type := skipType (getExprType (n)) ;
+         IF (type # NIL) AND isAProcType (type)
+         THEN
+            outText (p, '.proc')
+         END
       END
-   END
+   END ;
+   RETURN n
 END doExprCup ;
 
 
@@ -7040,31 +7132,10 @@ END outTextN ;
 
 
 (*
-   doTypeAliasC -
-*)
-
-PROCEDURE doTypeAliasC (p: pretty; n: node; VAR m: node) ;
-BEGIN
-   print (p, "typedef") ; setNeedSpace (p) ;
-   IF isTypeHidden (n) AND (isDef (getMainModule ()) OR (getScope (n) # getMainModule ()))
-   THEN
-      outText (p, "void *")
-   ELSE
-      doTypeC (p, getType (n), m)
-   END ;
-   IF m#NIL
-   THEN
-      doFQNameC (p, m)
-   END ;
-   print (p, ';\n\n')
-END doTypeAliasC ;
-
-
-(*
-   doEnumerationC -
+   outputEnumerationC -
 *)
 
-PROCEDURE doEnumerationC (p: pretty; n: node) ;
+PROCEDURE outputEnumerationC (p: pretty; n: node) ;
 VAR
    i, h: CARDINAL ;
    s   : node ;
@@ -7083,6 +7154,47 @@ BEGIN
       INC (i)
    END ;
    outText (p, "}")
+END outputEnumerationC ;
+
+
+(*
+   isDeclType - return TRUE if the current module should declare type.
+*)
+
+PROCEDURE isDeclType (type: node) : BOOLEAN ;
+VAR
+   n,
+   def : node ;
+   name: Name ;
+BEGIN
+   IF isImp (currentModule)
+   THEN
+      name := getSymName (type) ;
+      IF name # NulName
+      THEN
+         (* Lookup the matching .def module.  *)
+         def := lookupDef (getSymName (currentModule)) ;
+         IF def # NIL
+         THEN
+            (* Return TRUE if the symbol has not already been declared in the .def.  *)
+            RETURN lookupExported (def, name) = NIL
+         END
+      END
+   END ;
+   RETURN TRUE
+END isDeclType ;
+
+
+(*
+   doEnumerationC -
+*)
+
+PROCEDURE doEnumerationC (p: pretty; n: node) ;
+BEGIN
+   IF isDeclType (n)
+   THEN
+      outputEnumerationC (p, n)
+   END
 END doEnumerationC ;
 
 
